// SPDX-License-Identifier: MIT
// SPDX-FileCopyrightText: 2025 Loïc Le Page <llepage@igalia.com>

#pragma once

#include <EGL/egl.h>
#include <GLES3/gl3.h>
#include <libcamera/libcamera.h>

class CameraTexture final
{
  public:
    static std::unique_ptr<CameraTexture> create(EGLDisplay eglDisplay,
                                                 const libcamera::StreamConfiguration& streamConfiguration,
                                                 const libcamera::FrameBuffer& buffer) noexcept;
    ~CameraTexture();

    CameraTexture(CameraTexture&&) = delete;
    CameraTexture& operator=(CameraTexture&&) = delete;
    CameraTexture(const CameraTexture&) = delete;
    CameraTexture& operator=(const CameraTexture&) = delete;

    void bind() const noexcept;

  private:
    CameraTexture() = default;

    GLuint m_texture = 0;
};
