// SPDX-License-Identifier: MIT
// SPDX-FileCopyrightText: 2025 Loïc Le Page <llepage@igalia.com>

#pragma once

#include <EGL/egl.h>

class IRenderer
{
  public:
    virtual ~IRenderer() = default;

    virtual bool onInit(EGLDisplay eglDisplay) noexcept = 0;
    virtual void onShut() noexcept = 0;

    virtual void onFrameBufferResized(int width, int height) noexcept = 0;
    virtual void onRender(double time) noexcept = 0;
};
