// SPDX-License-Identifier: MIT
// SPDX-FileCopyrightText: 2025 Loïc Le Page <llepage@igalia.com>

#pragma once

#include <GLES3/gl3.h>

class Shader
{
  public:
    virtual ~Shader();

    Shader(Shader&&) = delete;
    Shader& operator=(Shader&&) = delete;
    Shader(const Shader&) = delete;
    Shader& operator=(const Shader&) = delete;

    void use() const noexcept;

  protected:
    Shader() = default;
    bool initGL(const char* vertexCode, const char* fragmentCode) noexcept;

    GLuint program() const noexcept
    {
        return m_program;
    }

  private:
    GLuint m_program = 0;
};
